def correlate(x,y)
  sum = 0.0
  x.each_index do |i|
    sum += x[i]*y[i]
  end
  xymean = sum/x.size.to_f
  xmean = mean(x)
  ymean = mean(y)
  sx = sigma(x)
  sy = sigma(y)
  (xymean-(xmean*ymean))/(sx*sy)
end

a = [3,6,9,12,15,18,21 ]
b = [1.1,2.1,3.4,4.8,5.6 ]
c = [1.9,1.0,3.9,3.1,6.9 ]
c1 = correlate(a,a)         # 1.0
c2 = correlate(a,a.reverse) # -1.0
c3 = correlate(b,c)         # 0.8221970228
