class Tree
    
  # Assumes definitions from
  # previous example...

  def infix()
    if @left != nil
      flag = %w[* / + -].include? @left.data
      yield "(" if flag
      @left.infix {|y| yield y}
      yield ")" if flag
    end
    yield @data
    if @right != nil
      flag = %w[* / + -].include? @right.data
      yield "(" if flag
      @right.infix {|y| yield y} if @right != nil
      yield ")" if flag
    end
  end

end

def addnode(nodes)
  node = nodes.shift
  tree = Tree.new node
  if %w[* / + -].include? node
    tree.left  = addnode nodes
    tree.right = addnode nodes
  end
  tree
end


prefix = %w[ * + 32 * 21 45 - 72 + 23 11 ]

tree = addnode prefix

str = ""
tree.infix {|x| str += x}
# str is now "(32+(21*45))*(72-(23+11))"
