def balanced_tags list
  stack = Stack.new
  opening = %w[ <html> <body> <b> <i> <u> <sub> <sup> ]
  closing = %w[ </html> </body> </b> </i> </u> </sub> </sup> ]
  list.each do |word| 
    if opening.include? word
      stack.push(word)
    elsif closing.include? word
      top = stack.peek
      if closing.index(top) != opening.index(word)
        return false 
      else
        stack.pop
      end
      # Ignore other words
    end
  end
  # Ensure stack is empty...
  return stack.empty?
end
    
text1 = %w[ <html> <body> This is <b> only </b> 
            a test. </body> </html> ]

text2 = %w[ <html> <body> Don't take it <i> too </i>
            seriously... </html> ]

balanced_tags(text1)    # true
balanced_tags(text2)    # false
